if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.achievement = {}
local this = lib.achievement

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.data = {}
	
	this.private.set = true
end

function this.AddByID(ID)
	this.private.Validate()
	
	--adding the same achievement multiple times is allowed
	if(this.private.data[ID] ~= nil) then
		return
	end
	
	this.private.data[ID] =
	{
		Name			= nil,
		IsCompletedAcc	= nil,
		IsCompletedChar	= nil,
		IsCompleted		= nil,
		Link			= nil,
		NumCriteria		= nil,
		CriteriaByID	= nil,
		CriteriaByIndex = nil
	}
	
	this.UpdateByID(ID)
	return
end

function this.UpdateByID(ID)
	this.private.Validate()
	
	local Ach = this.private.data[ID]
	
	if(Ach == nil) then
		lib.chat.error("trying to update achievement before adding it: "..ID)
		return
	end
	
	local achInfo = { GetAchievementInfo(ID) }
	Ach.Name = achInfo[2]
	Ach.IsCompletedAcc = achInfo[4]
	Ach.IsCompletedChar = achInfo[13]
	Ach.Link = GetAchievementLink(ID)
	Ach.NumCriteria = GetAchievementNumCriteria(ID)
	Ach.CriteriaByID = nil
	Ach.CriteriaByIndex = nil
	
	local CompletedCriteriaFound = false
	local UncompletedCriteriaFound = false
	
	if(Ach.NumCriteria >= 1) then
		Ach.CriteriaByID = {}
		Ach.CriteriaByIndex = {}
	end
		
	for i = 1, Ach.NumCriteria do
		local CritInfo = { GetAchievementCriteriaInfo(ID, i) }
		
		if(CritInfo[3] == true) then
			CompletedCriteriaFound = true
		else
			UncompletedCriteriaFound = true
		end
		
		Ach.CriteriaByIndex[i] = 
		{
			Name		= CritInfo[1],
			IsCompleted = CritInfo[3],
			ID			= CritInfo[10]
		}
		local CritID = CritInfo[10]
		if(CritID ~= nil and CritID ~= 0) then
			Ach.CriteriaByID[CritID] = 
			{
				Name		= CritInfo[1],
				IsCompleted = CritInfo[3],
				Index		= i
			}
		end
	end
	
	--set the "master" completion status depending on options
	if(	(Ach.IsCompletedChar == true) or
		((Ach.IsCompletedAcc == true) and (option.CharacterAchievements == false)) ) then
		Ach.IsCompleted = true
	else
		Ach.IsCompleted = false
	end
	
	--test for partial completion
	if(CompletedCriteriaFound == true and UncompletedCriteriaFound == true) then
		Ach.IsPartiallyCompleted = true
	end
	
	return
end

function this.GetByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] == nil) then
		lib.chat.error("trying to access achievement before adding it: "..ID)
		return
	end	
	
	return this.private.data[ID]
end
