if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.currency = {}
local this = lib.currency

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.data = {}
	
	this.private.set = true
end

function this.AddByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] ~= nil) then
		return
	end
	
	this.private.data[ID] = 
	{
		Name = nil,
		Amount = nil,
		TotalMax = nil,
		Link = nil
	}
	
	this.UpdateByID(ID)
	return true
end

--[[
function this.private.constructLink(name, id)
	if(name == nil) then
		name = "currency:"..id
	end
	
	--TODO: currently level 110 is hardcoded, may be a problem later
	local linkParts = {}
	linkParts[1] = "\124cffffffff\124Hcurrency:"
	linkParts[2] = "::::::::110:::::\124h["
	linkParts[3] = "]\124h\124r"
	
	return (linkParts[1]..id..LinkParts[2]..Name..LinkParts[3])
end
--]]

function this.UpdateByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] == nil) then
		lib.chat.error("trying to update currency that has not been added: "..ID)
		return nil
	end
	
	local CurrencyInfo = {GetCurrencyInfo(ID)}
	
	this.private.data[ID].Name = CurrencyInfo[1]
    this.private.data[ID].Amount = CurrencyInfo[2]
    this.private.data[ID].TotalMax = CurrencyInfo[6]
	this.private.data[ID].Link = GetCurrencyLink(ID, CurrencyInfo[2])
	
	return
end

function this.GetByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] == nil) then
		lib.chat.error("trying to access currency that has not been added: "..ID)
		return nil
	end
	
	return this.private.data[ID]
end
