if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.faction = {}
local this = lib.faction

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.PlayerFaction =
	{
		Alliance =	"Alliance",
		Horde		= "Horde",
		Neutral		= "Neutral"
	}
	this.private.data = {}
	
	this.private.set = true
end

function this.AddByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] ~= nil) then
		return
	end
	
	this.private.data[ID] = 
	{
		Name = nil,
		Description = nil,
		Paragon = nil
	}
	
	this.UpdateByID(ID)
	return true
end

--[[
function this.private.constructLink(name, id)
	if(name == nil) then
		name = "currency:"..id
	end
	
	--TODO: currently level 110 is hardcoded, may be a problem later
	local linkParts = {}
	linkParts[1] = "\124cffffffff\124Hcurrency:"
	linkParts[2] = "::::::::110:::::\124h["
	linkParts[3] = "]\124h\124r"
	
	return (linkParts[1]..id..LinkParts[2]..Name..LinkParts[3])
end
--]]

function this.UpdateByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] == nil) then
		lib.chat.error("trying to update faction that has not been added: "..ID)
		return nil
	end
	
	local FactionInfo = {GetFactionInfoByID(ID)}
	
	this.private.data[ID].Name = FactionInfo[1]
    this.private.data[ID].Description = FactionInfo[2]
	
	if(C_Reputation.IsFactionParagon(ID) == true) then
		local ParagonInfo = {C_Reputation.GetFactionParagonInfo(ID)}
		this.private.data[ID].Paragon =
		{
			CurrentRep			= ParagonInfo[1],
			NextRep				= ParagonInfo[2],
			RewardQuestID		= ParagonInfo[3],
			HasRewardPending	= ParagonInfo[4]
		}
	end
	
	return
end

function this.GetByID(ID)
	this.private.Validate()
	
	if(this.private.data[ID] == nil) then
		lib.chat.error("trying to access faction that has not been added: "..ID)
		return nil
	end
	
	return this.private.data[ID]
end

function this.GetPlayerFaction()
	this.private.Validate()

	local PlayerFaction = UnitFactionGroup(lib.unit.GetPlayerUnit())
	
	if(PlayerFaction == this.PlayerFaction.Alliance) then
		return this.PlayerFaction.Alliance
	elseif(PlayerFaction == this.PlayerFaction.Horde) then
		return this.PlayerFaction.Horde
	elseif(PlayerFaction == this.PlayerFaction.Neutral) then
		return this.PlayerFaction.Neutral
	else
		lib.chat.error("unknown PlayerFaction!")
		return nil
	end

end
