if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.tomtom = {}
local this = lib.tomtom

this.private = { set = false }
this.private.TomTomLinkType = "ttdTomTom"

function this.private.validate()
	if(this.private.set == false) then
		this.private.init()
	end

	return
end

function this.private.init()
	if(this.private.set) then
		lib.chat.error("init called more than once: lib.tomtom")
	end
	
	this.private.tomtom = nil
	if((_G.TomTom ~= nil) and (_G.TomTom.AddWaypoint ~= nil)) then
		this.private.tomtom = _G.TomTom
		this.private.oldHyperlinkShow = ChatFrame_OnHyperlinkShow
		ChatFrame_OnHyperlinkShow = this.private.OnHyperlinkShow
	end
	
	this.private.set = true
end

function this.private.OnHyperlinkShow(chatFrame, link, text, button)
	this.private.validate()
	
	local _,_,linkType,MapID, x, y, desc = string.find(link, "(%a-):(%d-):(.-):(.-):(.+)")
	--print("tomtom: ",linkType, mapID)
	if(linkType ~= this.private.TomTomLinkType) then
		return this.private.oldHyperlinkShow(chatFrame,link,text,button)
	end
	
	if(button == "RightButton") then
		return
	end

	MapID = tonumber(MapID)
	x = tonumber(x)
	y = tonumber(y)
	
	--lib.chat.error(mapID.." "..x.." "..y)
	
	if(lib.map.IsSameContinent(MapID) == false) then
		print(lib.chat.addonTitle()..": Different continent! Waypoint "..lib.chat.red("NOT").." added!")
		if(option.VerboseTomTom == true) then
			print("You: "..lib.map.GetMapGenealogy(lib.map.GetCurrentMapID()))
			print("Target: "..lib.map.GetMapGenealogy(MapID))
		end
		return
	end
		
	local opts = 
	{
		persistent = false,
		title = desc
	}
	this.private.tomtom:AddWaypoint(MapID,x,y,opts)
	--print(MapID,x,y,opts)
	return
end

function this.createLink(mapID,x,y,desc,LinkText)
	this.private.validate()
	
	if(LinkText == nil) then
		LinkText = desc
	end
	
	if(this.private.tomtom == nil) then
		return ("["..LinkText.."]")
	end
	
	--local opts = { persistent = false, title = desc }
	--this.private.tomtom:AddMFWaypoint(GetCurrentMapAreaID(),nil,x,y)
	local Link = (this.private.TomTomLinkType..":"..(mapID)..":"..(x)..":"..(y)..":"..(desc))
	if(option.VerboseTomTom == true) then
		local MapGenealogy = lib.map.GetMapGenealogy(mapID, " >> ")
		return ("\124H"..Link.."\124h[".."TomTom >> "..MapGenealogy.." >> "..desc.."]\124h")
	else
		local MapName = lib.map.GetNameByID(mapID)
		return ("\124H"..Link.."\124h[".."TT >> "..MapName.." >> "..desc.."]\124h")
	end
end
