if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.worldquest = {}
local this = lib.worldquest

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	this.private.set = true
end

function this.GetNameByID(ID)
	this.private.Validate()
	
	return C_TaskQuest.GetQuestInfoByQuestID(ID)
end

function this.IsActive(ID)
	this.private.Validate()
	
	local IsActive = C_TaskQuest.IsActive(ID)
	if(IsActive == false) then
		return false
	else
		--the MapID check is necessary as there are profession WQs that may be active but invisble (and incompleteable!) for the character, if the profession skill is too low
		local MapID = C_TaskQuest.GetQuestZoneID(ID)
		if(MapID == nil) then
			return false
		end
	end
	
	return true
end

function this.GetLocationByID(ID)
	this.private.Validate()
	
	local MapID = C_TaskQuest.GetQuestZoneID(ID)
	local PosX, PosY = C_TaskQuest.GetQuestLocation(ID,MapID)
	
	return MapID,PosX,PosY
end

function this.GetTimeLeftMinutes(ID)
	this.private.Validate()
	
	return C_TaskQuest.GetQuestTimeLeftMinutes(ID)
end

function this.GetTimeLeftHoursString(ID)
	this.private.Validate()
	
	local TimeLeftMinutes = this.GetTimeLeftMinutes(ID)
	local Message = "("..string.format(BLACK_MARKET_HOT_ITEM_TIME_LEFT,string.format(SPELL_DURATION_HOURS ,TimeLeftMinutes/60.0))..")"
	return Message
end

function this.PreloadRewards(ID)
	this.private.Validate()
	
	C_TaskQuest.RequestPreloadRewardData(ID)
	return
end

function this.DoesRewardItem(ID, ItemID)
	this.private.Validate()
	
	local NumItemRewards = GetNumQuestLogRewards(ID)
	if(NumItemRewards == 0) then
		return false
	end
	
	for i=1, NumItemRewards do
		local _, _, _, _, _, RewardItemID = GetQuestLogRewardInfo(i, ID)
		if(select(6, GetQuestLogRewardInfo(i, ID)) == ItemID) then
			return true
		end
	end

	return false
end
