if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.ArgusToys = {}
local this = ttd2.ArgusToys
this.Name = "[Argus] Toys"

--[[
The purpose of this module is to show your status on the various toys found in the argus outdoor content.
]]

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--Note: The 3 mobs not used by WQs are always up.
	this.private.Toys =
	{
		{ ItemID = 153126, src = { MapID = 885, x = 0.619, y = 0.643, FlagQuest = 48814, WQuest = 48829, Name = "Yarez" } },
		{ ItemID = 153253, src = { MapID = 885, x = 0.774, y = 0.749, FlagQuest = 48967, WQuest = nil, Name = "Vishax", preQuest = 49007 } },
		{ ItemID = 153194, src = { MapID = 885, x = 0.586, y = 0.118, FlagQuest = 48968, WQuest = nil, Name = "Suprax", extraInfo = "requires 3 players to summon" } },				
		{ ItemID = 153293, src = { MapID = 885, x = 0.650, y = 0.826, FlagQuest = 48971, WQuest = nil, Name = "Rezira", requItem = 153226 } },
		{ ItemID = 153124, src = { MapID = 830, x = 0.534, y = 0.309, FlagQuest = 48565, WQuest = 48512, Name = "Subversia" } },
		
		{ ItemID = 153183, src = { MapID = 882, x = 0.363, y = 0.236, FlagQuest = 48703, WQuest = 48723, Name = "Thanos" } },
		{ ItemID = 153183, src = { MapID = 882, x = 0.638, y = 0.646, FlagQuest = 48704, WQuest = 48724, Name = "Kuro" } },
		
		{ ItemID = 153179, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, Name = "Tarahna" } },
		{ ItemID = 153180, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, Name = "Tarahna" } },
		{ ItemID = 153181, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, Name = "Tarahna" } },
		{ ItemID = 153193, src = { MapID = 882, x = 0.438, y = 0.602, FlagQuest = 48700, WQuest = 48701, Name = "Baruut" } }
	}
	
	local Toys = this.private.Toys
	for _,Toy in pairs(Toys) do
		lib.item.AddByID(Toy.ItemID)
		lib.journal.toy.AddByID(Toy.ItemID)
		lib.quest.AddByID(Toy.src.FlagQuest)
		if(Toy.src.preQuest ~= nil) then
			lib.quest.AddByID(Toy.src.preQuest)
		end
		if(Toy.src.requItem ~= nil) then
			lib.item.AddByID(Toy.src.requItem)
		end
		if(Toy.src.WQuest ~= nil) then
			Toy.src.Name = lib.worldquest.GetNameByID(Toy.src.WQuest)
		end
	end
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local Toys = this.private.Toys
	
	for _,Toy in pairs(Toys) do
		lib.item.UpdateByID(Toy.ItemID)
		lib.journal.toy.UpdateByID(Toy.ItemID)
		lib.quest.UpdateByID(Toy.src.FlagQuest)
		if(Toy.src.preQuest ~= nil) then
			lib.quest.UpdateByID(Toy.src.preQuest)
		end
		if(Toy.src.requItem ~= nil) then
			lib.item.UpdateByID(Toy.src.requItem)
		end
	end
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	for _,Toy in pairs(Toys) do
		local ToyData = lib.journal.toy.GetByID(Toy.ItemID)
		local Link = lib.item.GetByID(Toy.ItemID).Link
		local TomTom = lib.tomtom.createLink(Toy.src.MapID, Toy.src.x, Toy.src.y, Toy.src.Name)
		
		if(ToyData.IsCollected) then
			out.StoreCompleted(Link)
		elseif(lib.quest.GetByID(Toy.src.FlagQuest).IsCompleted) then
			out.StoreDone(Link)
		elseif(Toy.src.WQuest == nil) then
			--these are the three special non-rares
			Link = Link.." - "..TomTom
			
			if(Toy.src.extraInfo ~= nil) then
				Link = Link.." ("..Toy.src.extraInfo..")"
			end
			
			if(Toy.src.requItem ~= nil) then
				Link = Link.." (requires "..lib.item.GetByID(Toy.src.requItem).Link..")"
			end
			
			if(Toy.src.preQuest ~= nil and (not lib.quest.GetByID(Toy.src.preQuest).IsCompleted)) then
				Link = Link.." (requires "..lib.quest.GetByID(Toy.src.preQuest).Link..")"
			end
			
			out.StoreTodo(Link)
			
		elseif(lib.worldquest.IsActive(Toy.src.WQuest) == true) then
			out.StoreTodo(Link.." - "..lib.chat.complex.GetWQStatusString(Toy.src.WQuest))
		else
			--now treat as rare mobs
			out.StoreRare(Link.." - "..TomTom)
		end
	end
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
