if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAWQAchievements = {}
local this = ttd2.BFAWQAchievements
this.Name = "[BFA] WQ-Achievements"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	local MyLevel = lib.unit.GetPlayerLevel()
	
	--nothing in this module is reachable before lvl 110
	if(MyLevel < 110) then
		return
	end
	
	local MyFaction = lib.unit.GetPlayerFaction()
	if(MyFaction == "Alliance") then
		this.private.data =
		{
			{
				AchievementID = 13035,	--Bei der Macht der Loa!
				Quests =
				{
					WQID = 51178
				}
			},
			{
				AchievementID = 13050,	--Feuerwerk in Freihafen
				Quests =
				{
					OneTimeID = 49403,
					WQID = 52159
				},
				CriteriaWaypoints =
				{
					{ ID = 41662, MapID = 895, PosX = 0.7615, PosY = 0.8460 },	--Banana Hoard
					{ ID = 41663, MapID = 895, PosX = 0.7338, PosY = 0.8392 },	--Sweete's Feast
					{ ID = 41664, MapID = 895, PosX = 0.7505, PosY = 0.8294 },	--Cart o' Cutlasses
					{ ID = 41665, MapID = 895, PosX = 0.7669, PosY = 0.8180 }	--Blacktooth Brew
				}
			},
			{
				AchievementID = 13054,--Ich bin Säbeltron, evtl. weitere WQIDs nötig!!
				Criteria =
				{
					{ ID = 41421, WQID = 51977 },	--yellow
					{ ID = 41422, WQID = 51978 },	--orange
					{ ID = 41423, WQID = 51976 },	--green
					{ ID = 41424, WQID = 51974 }	--copper
				}
			},
			{
				AchievementID = 13042,	--Kurz vor dem Zusammenbruch
				Quests =
				{
					OneTimeID = 53099,
					WQIDs = { 53106, 53107, 53108 }
				}
			},
			{
				AchievementID = 13023,	--Völlig außer Hand und Band
				Quests =
				{
					WQID = 51127
				}
			},
			{
				AchievementID = 13059,	--Abgeschleppt
				Quests =
				{
					OneTimeID = 48088,
					WQID = 53346
				}
			},
			{
				AchievementID = 13060,	--Kule Schlittenfahrt
				Criteria =
				{
					{ ID = 41764, WQID = 49994 },
					{ ID = 41766, WQID = 53188 },
					{ ID = 41768, WQID = 53189 }
				}
			},
			{
				AchievementID = 13026,	--Spionfänger der 7. Legion
				Quests =
				{
					WQID = 50899
				}
			},
			{
				AchievementID = 12940,	--Adventurer of Stormsong Valley
				Criteria =
				{
					{ ID = 41841, WQID = 52299 }
				}
			},
			{
				AchievementID = 13283,	--Frontkämpfer
				IncursionZoneCriteria =
				{
					[895] = 43630,	--tiragarde
					[942] = 43680,	--stormsong
					[896] = 43637,	--drustvar
					[864] = 43681,	--voldun
					[863] = 43682,	--nazmir
					[862] = 43683	--zuldazar
				}
			},
			{
				AchievementID = 13426,	--Come On and Slam(Incursion)
				Quests =
				{
					WQID = 54512
				}
			},
			{
				AchievementID = 13440,	--Pushing the Payload(Incursion)
				Quests =
				{
					WQID = 54498
				}
			},
			{
				AchievementID = 13285,	--Redliche Bürger(Incursion)
				Quests =
				{
					WQID = 53704
				}
			}
		}
	elseif(MyFaction == "Horde") then
		this.private.data =
		{
			{
				AchievementID = 13035,	--Bei der Macht der Loa!
				Quests =
				{
					WQID = 51232
				}
			},
			{
				AchievementID = 13050,	--Feuerwerk in Freihafen
				Quests =
				{
					WQID = 53196
				},
				CriteriaWaypoints =
				{
					{ ID = 41662, MapID = 895, PosX = 0.7615, PosY = 0.8460 },	--Banana Hoard
					{ ID = 41663, MapID = 895, PosX = 0.7338, PosY = 0.8392 },	--Sweete's Feast
					{ ID = 41664, MapID = 895, PosX = 0.7505, PosY = 0.8294 },	--Cart o' Cutlasses
					{ ID = 41665, MapID = 895, PosX = 0.7669, PosY = 0.8180 }	--Blacktooth Brew
				}
			},
			{
				AchievementID = 13054,--Ich bin Säbeltron, evtl. weitere WQIDs nötig!!
				Criteria =
				{
					{ ID = 41421, WQID = 51977 },	--yellow
					{ ID = 41422, WQID = 51978 },	--orange
					{ ID = 41423, WQID = 51976 },	--green
					{ ID = 41424, WQID = 51974 }	--copper
				}
			},
			{
				AchievementID = 13042,	--Kurz vor dem Zusammenbruch
				Quests =
				{
					OneTimeID = 53099,
					WQIDs = { 53343, 53344, 53345 }
				}
			},
			{
				AchievementID = 13023,	--Völlig außer Hand und Band
				Quests =
				{
					WQID = 50559
				}
			},
			{
				AchievementID = 13025,	--Spionfänger
				Quests =
				{
					WQID = 50717
				}
			},
			{
				AchievementID = 13009,	--Erfahrener Sandangler
				Quests =
				{
					WQID = 51173
				}
			},
			{
				AchievementID = 13021,	--Keine Zeit für die Apokalypse
				Quests =
				{
					WQID = 50665
				}
			},
			{
				AchievementID = 13022,	--Rache wird am besten schnell serviert
				Quests =
				{
					WQID = 50786
				}
			},
			{
				AchievementID = 13041,	--Rein in den Ranishuranzen
				Quests =
				{
					OneTimeID = 51991,
					WQID = 52798
				}
			},
			{
				AchievementID = 13014,	--Vorriks Champion
				Criteria =
				{
					{ ID = 41356, WQID = 51975 },
					{ ID = 41357, WQID = 51983 }
				}
			},
			{
				AchievementID = 12940,	--Adventurer of Stormsong Valley
				Criteria =
				{
					{ ID = 41841, WQID = 52299 }
				}
			},
			{
				AchievementID = 13284,	--Frontline Warrior / Frontkämpfer (Incursion)
				IncursionZoneCriteria =
				{
					[895] = 43642,	--tiragarde
					[863] = 43684,	--nazmir
					[864] = 43685,	--voldun
					[862] = 43686,	--zuldazar
					[896] = 43687,	--drustvar
					[942] = 43688	--stormsong
				}
			},
			{
				AchievementID = 13441,	--Pushing the Payload / Ran an die Fracht (Incursion)
				Quests =
				{
					WQID = 54505
				}
			},
			{
				AchievementID = 13435,	--Doomsoul Surprise / In aller Seelenruhe (Incursion)
				Quests =
				{
					WQID = 54689
				}
			},
			{
				AchievementID = 13437,	--Scavenge like a Vulpera / Gehn wie ein Vulpera (Incursion)
				Quests =
				{
					WQID = 54415
				}
			}
		}
	end
	
	--the panda case
	if(this.private.data == nil) then
		return
	end
	
	for _,Ach in pairs(this.private.data) do
		lib.achievement.AddByID(Ach.AchievementID)
		if(Ach.Quests ~= nil) then
			if(Ach.Quests.OneTimeID ~= nil) then
				lib.quest.AddByID(Ach.Quests.OneTimeID)
			end
		end
		if(Ach.Criteria ~= nil) then
			for _,Crit in pairs(Ach.Criteria) do
			end
		end
	end
	
	return
end

function this.private.PrintAchievementWaypoints(Ach, out)
	this.private.Validate()
	
	local AchData = lib.achievement.GetByID(Ach.AchievementID)
	local CritWPs = Ach.CriteriaWaypoints
	if(CritWPs == nil) then
		return
	end
	
	for _, WP in pairs(CritWPs) do
		local Crit = AchData.CriteriaByID[WP.ID]
		local Link = lib.tomtom.createLink(WP.MapID, WP.PosX, WP.PosY, Crit.Name)
		if(Crit.IsCompleted == true) then
			out.StoreCompleted(Link)
		else
			out.StoreTodo(Link)
		end
	end	
	return
end

function this.private.TestCriteriaWQUp(AchData, Criteria)
	this.private.Validate()
	
	for _,Crit in pairs(Criteria) do
		local CritData = AchData.CriteriaByID[Crit.ID]
		if((CritData.IsCompleted == false) and (lib.worldquest.IsActive(Crit.WQID))) then
			return true
		end
	end	
	return false
end

function this.private.TestAnyWQUp(WQIDs)
	this.private.Validate()
	
	for _,WQID in pairs(WQIDs) do
		if(lib.worldquest.IsActive(WQID)) then
			return WQID
		end
	end	
	return nil
end

function this.private.CheckAchievementQuestStatus(Ach, out)
	this.private.Validate()
	
	local AchData = lib.achievement.GetByID(Ach.AchievementID)
	
	if(AchData.IsCompleted == true) then
		out.StoreCompleted(AchData.Link)
		return
	end
	
	--first check if the Ach can be done during a one-time-quest
	local OTQ = nil
	if(Ach.Quests ~= nil and Ach.Quests.OneTimeID ~= nil) then
		OTQ = lib.quest.GetByID(Ach.Quests.OneTimeID)
	end
			
	if(OTQ ~= nil and OTQ.IsCompleted ~= true) then
		out.StoreTodo(AchData.Link.." << "..OTQ.Link)
		--the following function prints additional helper-waypoints. currently only used for freeport bombing ach
		this.private.PrintAchievementWaypoints(Ach, out)
		return
	end
	
	--at this point we know that there either is no OTQ or it is completed already. So check single WQ!
	local WQID = nil
	if(Ach.Quests ~= nil and Ach.Quests.WQID ~= nil) then
		WQID = Ach.Quests.WQID
	end
	
	if(WQID ~= nil) then
		if(lib.worldquest.IsActive(WQID) == true) then
			out.StoreTodo(AchData.Link.." - "..lib.chat.complex.GetWQStatusString(WQID))
			
			--the following function prints additional helper-waypoints. currently only used for freeport bombing ach
			this.private.PrintAchievementWaypoints(Ach, out)
		else
			out.StoreDone(AchData.Link)
		end
		return
	end
	
	--next check for multiple WQs that all allow one Ach to be done
	local WQIDs = nil
	if(Ach.Quests ~= nil and Ach.Quests.WQIDs ~= nil) then
		WQIDs = Ach.Quests.WQIDs
	end
	
	if(WQIDs ~= nil) then
		local WQUp = this.private.TestAnyWQUp(WQIDs)
		
		if(WQUp == nil) then
			out.StoreDone(AchData.Link)
		else
			out.StoreTodo(AchData.Link.." - "..lib.chat.complex.GetWQStatusString(WQUp))
		end
		
		return
	end
	
	--now check for individual critera WQs as part of one single Ach
	local Criteria = Ach.Criteria	
	if(Criteria ~= nil) then
		
		local CriteriaMissing = 0
		local AnyMissingWQUp = false --this.private.TestCriteriaWQUp(AchData, Criteria)
		
		for _,Crit in pairs(Criteria) do
			local CritData = AchData.CriteriaByID[Crit.ID]
			if(CritData.IsCompleted == false) then
				CriteriaMissing = CriteriaMissing+1
				if(lib.worldquest.IsActive(Crit.WQID)) then
					AnyMissingWQUp = true
				end
			end
		end
		
		if(CriteriaMissing == 0) then
			out.StoreCompleted(AchData.Link)
		elseif(AnyMissingWQUp == true) then
			out.StoreTodo(AchData.Link)
		else
			out.StoreDone(AchData.Link)
		end
		
		for _,Crit in pairs(Criteria) do
			local CritData = AchData.CriteriaByID[Crit.ID]
			if(CritData.IsCompleted == true) then
				out.StoreCompleted(CritData.Name)
			elseif(lib.worldquest.IsActive(Crit.WQID)) then
				out.StoreTodo(lib.chat.complex.GetWQStatusString(Crit.WQID))
			else
				out.StoreDone(CritData.Name)
			end
		end

		return
	end
	
	--now check incursion completion
	local IncursionCriteria = Ach.IncursionZoneCriteria
	if(IncursionCriteria ~= nil) then
		--do something!
		local IncursionMapID			= lib.incursion.GetIncursionMapID()
		local ActiveIncursionCriteriaID	= nil
		local ActiveIncursionCriteria	= nil
		if(IncursionMapID == nil) then
			--no incursion up!
			out.StoreDone(AchData.Link)
		else
			ActiveIncursionCriteriaID	= IncursionCriteria[IncursionMapID]
			ActiveIncursionCriteria		= AchData.CriteriaByID[ActiveIncursionCriteriaID]
			if(ActiveIncursionCriteria.IsCompleted == true) then
				--we do not need the current incursion
				out.StoreDone(AchData.Link)
				--out.StoreCompleted(ActiveIncursionCriteria.Name)
			else
				out.StoreTodo(AchData.Link)
				--out.StoreTodo(ActiveIncursionCriteria.Name)
			end
		end
		
		for CritID,CritData in pairs(AchData.CriteriaByID) do
			if(CritData.IsCompleted == true) then
				out.StoreCompleted(CritData.Name)
			elseif(CritID == ActiveIncursionCriteriaID) then
				out.StoreTodo(CritData.Name)
			else
				out.StoreDone(CritData.Name)
			end
		end
		return
	end
	
	
	--this point should never be reached
	lib.chat.error("Faulty data in BFAWQAchievements.")
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	--the panda / lvl case
	if(this.private.data == nil) then
		return
	end	
	
	for _,Ach in pairs(this.private.data) do
		lib.achievement.UpdateByID(Ach.AchievementID)
		if(Ach.Quests ~= nil) then
			if(Ach.Quests.OneTimeID ~= nil) then
				lib.quest.UpdateByID(Ach.Quests.OneTimeID)
			end
		end
	end
	
	
	
	for _,Ach in pairs(this.private.data) do
		this.private.CheckAchievementQuestStatus(Ach, out)
	end
	
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
