if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAWQRecipes = {}
local this = ttd2.BFAWQRecipes
this.Name = "[BFA] WQ-Recipes"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--first some exclusions
	local MyLevel = lib.unit.GetPlayerLevel()
	if(MyLevel < 120) then
		return
	end
	
	--in this table we will sort the WQs nicely for better readability and bug-tracking
	local AllWQRecipes =
	{
		["Neutral"] =
		{
			["Cooking"] =
			{
				ProfessionID	= 185,
				Recipes			=
				{
					{ ItemID = 162285, WQID = 52344 },	--Recipe: Kul Tiramisu
					{ ItemID = 162290, WQID = 52345 },	--Recipe: Ravenberry Tarts
					{ ItemID = 162295, WQID = 52346 },	--Recipe: Sailor's Pie
					{ ItemID = 162286, WQID = 52347 },	--Recipe: Honey-Glazed Haunches
					{ ItemID = 162296, WQID = 52348 },	--Recipe: Mon'Dazi
					{ ItemID = 162294, WQID = 52349 },	--Recipe: Loa Loaf
					{ ItemID = 162291, WQID = 52350 },	--Recipe: Swamp Fish 'n Chips
					{ ItemID = 162297, WQID = 52351 }	--Recipe: Spiced Snapper
				}
			},
			["Inscription"] =
			{
				ProfessionID	= 773,
				Recipes			=
				{
					{ ItemID = 162321, WQID = 52393 },	--Recipe: Contract: Tortollan Seekers
					{ ItemID = 162321, WQID = 52394 }	--Recipe: Contract: Champions of Azeroth
				}
			}
		},
		["Alliance"] =
		{
			["Alchemy"] =
			{
				ProfessionID	= 171,
				Recipes			= 
				{
					{ ItemID = 162257, WQID = 52331 },	--Recipe: Demitri's Draught of Deception
					{ ItemID = 162258, WQID = 52332 },	--Recipe: Lightfoot Potion
					{ ItemID = 162259, WQID = 52333 },	--Recipe: Sea Mist Potion
					{ ItemID = 162260, WQID = 52334 }	--Recipe: Potion of Concealment
				}
			},
			["Enchanting"] =
			{
				ProfessionID	= 333,
				Recipes			=
				{
					{ ItemID = 162299, WQID = 52353 },	--Formula: Enchant Ring - Seal of Haste
					{ ItemID = 162300, WQID = 52354 },	--Formula: Enchant Ring - Seal of Mastery
					{ ItemID = 162315, WQID = 52355 },	--Formula: Enchant Weapon - Coastal Surge
					{ ItemID = 162319, WQID = 52356 },	--Formula: Enchant Weapon - Torrent of Elements
					{ ItemID = 162314, WQID = 52357 }	--Formula: Enchant Weapon - Quick Navigation
				}
			},			
			["Engineering"] =
			{
				ProfessionID	= 202,
				Recipes			=
				{
					{ ItemID = 162321, WQID = 52363 },	--Schematic: Incendiary Ammunition
					{ ItemID = 162332, WQID = 52364 },	--Schematic: Thermo-Accelerated Plague Spreader
					{ ItemID = 162331, WQID = 52365 },	--Schematic: F.R.I.E.D.
					{ ItemID = 162339, WQID = 52366 },	--Schematic: XA-1000 Surface Skimmer
					{ ItemID = 162340, WQID = 52367 },	--Schematic: Electroshock Mount Motivator
					{ ItemID = 162343, WQID = 52368 }	--Schematic: Crow's Nest Scope
				}
			},			
			["Inscription"] =
			{
				ProfessionID	= 773,
				Recipes			=
				{
					{ ItemID = 162360, WQID = 52389 },	--Recipe: Contract: Proudmoore Admiralty
					{ ItemID = 162362, WQID = 52390 },	--Recipe: Contract: Order of Embers
					{ ItemID = 162364, WQID = 52391 }	--Recipe: Contract: Storm's Wake
				}
			},			
			["Tailoring"] =
			{
				ProfessionID	= 197,
				Recipes			=
				{
					{ ItemID = 162443, WQID = 52422 },	--Pattern: Battle Flag: Spirit of Freedom
					{ ItemID = 162444, WQID = 52423 },	--Pattern: Battle Flag: Phalanx Defense
					{ ItemID = 162445, WQID = 52424 }	--Pattern: Battle Flag: Rallying Swiftness
				}
			}
		},
		["Horde"] =
		{
			["Alchemy"] =
			{
				ProfessionID	= 171,
				Recipes			= 
				{
					{ ItemID = 162257, WQID = 52335 },	--Recipe: Demitri's Draught of Deception
					{ ItemID = 162258, WQID = 52336 },	--Recipe: Lightfoot Potion
					{ ItemID = 162259, WQID = 52337 },	--Recipe: Sea Mist Potion
					{ ItemID = 162260, WQID = 52338 }	--Recipe: Potion of Concealment
				}
			},
			["Enchanting"] =
			{
				ProfessionID	= 333,
				Recipes			=
				{
					{ ItemID = 162299, WQID = 52358 },	--Formula: Enchant Ring - Seal of Haste
					{ ItemID = 162300, WQID = 52359 },	--Formula: Enchant Ring - Seal of Mastery
					{ ItemID = 162315, WQID = 52360 },	--Formula: Enchant Weapon - Coastal Surge
					{ ItemID = 162319, WQID = 52361 },	--Formula: Enchant Weapon - Torrent of Elements
					{ ItemID = 162314, WQID = 52362 }	--Formula: Enchant Weapon - Quick Navigation
				}
			},			
			["Engineering"] =
			{
				ProfessionID	= 202,
				Recipes			=
				{
					{ ItemID = 162321, WQID = 52369 },	--Schematic: Incendiary Ammunition
					{ ItemID = 162332, WQID = 52370 },	--Schematic: Thermo-Accelerated Plague Spreader
					{ ItemID = 162331, WQID = 52371 },	--Schematic: F.R.I.E.D.
					{ ItemID = 162339, WQID = 52372 },	--Schematic: XA-1000 Surface Skimmer
					{ ItemID = 162340, WQID = 52373 },	--Schematic: Electroshock Mount Motivator
					{ ItemID = 162343, WQID = 52374 }	--Schematic: Crow's Nest Scope
				}
			},			
			["Inscription"] =
			{
				ProfessionID	= 773,
				Recipes			=
				{
					{ ItemID = 162321, WQID = 52393 },	--Recipe: Contract: Tortollan Seekers
					{ ItemID = 162321, WQID = 52394 },	--Recipe: Contract: Champions of Azeroth
					{ ItemID = 162366, WQID = 52395 },	--Recipe: Contract: Zandalari Empire
					{ ItemID = 162368, WQID = 52396 },	--Recipe: Contract: Talanji's Expedition
					{ ItemID = 162370, WQID = 52397 }	--Recipe: Contract: Voldunai
				}
			},			
			["Tailoring"] =
			{
				ProfessionID	= 197,
				Recipes			=
				{
					{ ItemID = 162443, WQID = 52425 },	--Pattern: Battle Flag: Spirit of Freedom
					{ ItemID = 162444, WQID = 52426 },	--Pattern: Battle Flag: Phalanx Defense
					{ ItemID = 162445, WQID = 52427 }	--Pattern: Battle Flag: Rallying Swiftness
				}
			}
		}
	}
	
	--build a data table based on our actual faction
	local MyFaction = lib.unit.GetPlayerFaction()
	
	local function TransferData(From, To)
		for _,Profession in pairs(From) do
			To[Profession.ProfessionID] = {}
			for _,Recipe in pairs(Profession.Recipes) do
				To[Profession.ProfessionID][Recipe.ItemID] = Recipe.WQID
			end
		end
	end
	
	if(MyFaction == "Neutral") then
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
	elseif(MyFaction == "Alliance") then	
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
		TransferData(AllWQRecipes["Alliance"], this.private.WQRecipes)
	elseif(MyFaction == "Horde") then	
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
		TransferData(AllWQRecipes["Horde"], this.private.WQRecipes)
	else
		--in case some strange panda-wannabe ever tries this in the future...
		lib.chat.error(this.Name..": invalid player faction: "..MyFaction)
	end
	
	--init recipe ItemID data
	for ProfessionID,ProfessionData in pairs(this.private.WQRecipes) do
		for ItemID,WQID in pairs(ProfessionData) do
			lib.item.AddByID(ItemID)
		end
	end
	
	return
end

function this.private.Update()
	this.private.Validate()	
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	if(this.private.WQRecipes == nil) then
		return
	end
	
	--assume tooltips are ready
	this.private.StillLoadingTooltips = false
	for ProfID,ProfData in pairs(this.private.WQRecipes) do
	
		--Spartans, what is your profession?
		if(lib.professions.DoesCharacterHaveProfession(ProfID) == true) then
			
			for ItemID,WQID in pairs(ProfData) do
				
				if(lib.recipe.IsRecipeInfoAvailable(ItemID) == false) then
					--it's important to still continue looping after finding the first incomplete tooltip to batch API requests
					this.private.StillLoadingTooltips = true
				else
				
					lib.worldquest.PreloadRewards(WQID)
					
					local RecipeStatus	= lib.recipe.IsRecipeLearned(ItemID)
					local WQStatus		= lib.worldquest.IsActive(WQID)
					local RewardStatus	= lib.worldquest.DoesRewardItem(WQID, ItemID)
					
					if(RecipeStatus == true) then
						out.StoreCompleted(lib.item.GetByID(ItemID).Link)
					elseif(WQStatus == true) then
						local Message = lib.item.GetByID(ItemID).Link.." - "..lib.chat.complex.GetWQStatusString(WQID)
						if(RewardStatus == false) then
							out.StoreTodo(lib.chat.red("WARNING: ").."your profession-skill is too low to get the recipe rewarded!\n"..Message)
						else
							out.StoreTodo(Message)
						end
					else
						out.StoreDone(lib.item.GetByID(ItemID).Link.." - "..lib.chat.complex.GetWQStatusString(WQID))
					end
				end
			end
		end
	end
		
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	
	if(	(lib.chat.output.GetNumLines() ~= 0) or
		(this.private.StillLoadingTooltips == true) )then
		return true
	end
	
	--lib.chat.output.PrintModule(this.Name)
	
	return false
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	
	if(this.private.StillLoadingTooltips == true) then
		lib.chat.output.ClearBuffer()
		lib.chat.output.StoreTodo("Loading tooltips. Please wait a few seconds and try again.")
	elseif(lib.chat.output.GetNumLines() == 0) then
		lib.chat.output.ClearBuffer()
		lib.chat.output.StoreTodo("Please refresh modules.")
	end
	
	lib.chat.output.PrintModule(this.Name)
	
	--	/run ThingsToDo2.lib.tooltip.RequestItemByID(162443)
	--	/run ThingsToDo2.lib.tooltip.PrintAllFontRegions()
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
